=== debian/changelog ===
vmemcache (0.8-4) unstable; urgency=medium

  * Install the man page.
  * Fix an intermittent test failure on 32-bit.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 19 Jul 2019 01:45:46 +0200

vmemcache (0.8-3) unstable; urgency=medium

  * Hard-code -latomic.
  * Avoid some Linuxisms.
  * Handle missing PATH_MAX.
  * Don't assume hard-coded sizes of pthread types.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 02 May 2019 17:31:06 +0200

vmemcache (0.8-2) unstable; urgency=medium

  * Unbreak tests on 32-bit archs.
  * Migrate from __sync_fetch to __atomic_fetch, link with -latomic.
  * Don't Build-Depend on valgrind on archs that lack it.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 29 Apr 2019 15:25:03 +0200

vmemcache (0.8-1) unstable; urgency=medium

  * Initial release (Closes: #925980)

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 29 Mar 2019 19:00:34 +0100
