=== debian/control ===
Source: vmemcache
Priority: optional
Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends:
	cmake,
	debhelper (>= 11),
	pandoc,
	pkg-config,
	valgrind [amd64 arm64 armhf i386 mips mipsel mips64 mips64el powerpc ppc64 ppc64el s390x x32]
Standards-Version: 4.3.0
Section: libs
Homepage: https://github.com/pmem/vmemcache
Vcs-Browser: https://github.com/kilobyte/vmemcache/tree/debian
Vcs-Git: https://github.com/kilobyte/vmemcache -b debian

Package: libvmemcache-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libvmemcache0 (= ${binary:Version}), ${misc:Depends}
Description: buffer-based LRU cache
 Vmemcache is a volatile filesystem based key:value cache.  It works best
 when backed with a DAX-capable persistent memory device, but can work on
 tmpfs or on legacy disks.
 .
 This package contains development headers and documentation.

Package: libvmemcache0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: buffer-based LRU cache
 Vmemcache is a volatile filesystem based key:value cache.  It works best
 when backed with a DAX-capable persistent memory device, but can work on
 tmpfs or on legacy disks.
 .
 This package contains the runtime library.
