=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%vmemcache-$1.tar.gz%" \
   https://github.com/pmem/vmemcache/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
