## vmemcache 0.8.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,33 +1,5 @@
-#
+# SPDX-License-Identifier: BSD-3-Clause
 # Copyright 2018-2019, Intel Corporation
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-#
-#     * Redistributions of source code must retain the above copyright
-#       notice, this list of conditions and the following disclaimer.
-#
-#     * Redistributions in binary form must reproduce the above copyright
-#       notice, this list of conditions and the following disclaimer in
-#       the documentation and/or other materials provided with the
-#       distribution.
-#
-#     * Neither the name of the copyright holder nor the names of its
-#       contributors may be used to endorse or promote products derived
-#       from this software without specific prior written permission.
-#
-# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
-# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
-# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
-# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
-# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
-# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
-# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
-# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 cmake_minimum_required(VERSION 3.3)
 project(vmemcache C)
@@ -103,12 +75,14 @@
 	add_c_flag(-fno-common)
 	add_c_flag(-Wall)
 	add_c_flag(-Wconversion)
+	add_c_flag(-Wfloat-equal)
 	add_c_flag(-Wmissing-field-initializers)
 	add_c_flag(-Wmissing-prototypes)
 	add_c_flag(-Wmissing-variable-declarations)
 	add_c_flag(-Wpointer-arith)
 	add_c_flag(-Wsign-compare)
 	add_c_flag(-Wsign-conversion)
+	add_c_flag(-Wswitch-default)
 	add_c_flag(-Wunused-macros)
 	add_c_flag(-Wunreachable-code-return)
 	add_c_flag(-Werror=incompatible-pointer-types)
@@ -145,8 +119,6 @@
 
 add_custom_target(uninstall
 	COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
-
-add_executable(check_license EXCLUDE_FROM_ALL utils/check_license/check-license.c)
 
 function(add_cstyle name)
 	if(${ARGC} EQUAL 1)
@@ -191,16 +163,8 @@
 add_custom_target(check-license
 	COMMAND ${CMAKE_SOURCE_DIR}/utils/check_license/check-headers.sh
 	${CMAKE_SOURCE_DIR}
-	${CMAKE_BINARY_DIR}/check_license
-	${CMAKE_SOURCE_DIR}/LICENSE
-	-a)
-
-add_dependencies(check-license check_license)
-
-add_cstyle(check_license
-	${CMAKE_SOURCE_DIR}/utils/check_license/*.c)
-add_check_whitespace(check_license
-	${CMAKE_SOURCE_DIR}/utils/check_license/*.c)
+	BSD-3-Clause)
+
 add_check_whitespace(other
 	${CMAKE_SOURCE_DIR}/utils/check_license/*.sh
 	${CMAKE_SOURCE_DIR}/README.md)
@@ -212,7 +176,6 @@
 	add_c_flag(-Werror)
 	add_dependencies(checkers cstyle)
 	add_dependencies(checkers check-whitespace)
-	add_dependencies(checkers check-license)
 endif(DEVELOPER_MODE)
 
 option(TRACE_TESTS
