=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,33 +1,5 @@
-#
+# SPDX-License-Identifier: BSD-3-Clause
 # Copyright 2018-2019, Intel Corporation
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-#
-#     * Redistributions of source code must retain the above copyright
-#       notice, this list of conditions and the following disclaimer.
-#
-#     * Redistributions in binary form must reproduce the above copyright
-#       notice, this list of conditions and the following disclaimer in
-#       the documentation and/or other materials provided with the
-#       distribution.
-#
-#     * Neither the name of the copyright holder nor the names of its
-#       contributors may be used to endorse or promote products derived
-#       from this software without specific prior written permission.
-#
-# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
-# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
-# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
-# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
-# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
-# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
-# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
-# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 set(DEFAULT_TEST_DIR ${CMAKE_CURRENT_BINARY_DIR}/test)
 
@@ -61,11 +33,6 @@
 				"This is the Coverage build, skipping Valgrind test: ${name}")
 			return()
 		endif()
-	endif()
-
-	if ((COVERAGE_BUILD) AND (${tracer} STREQUAL helgrind))
-		message(STATUS "This is the Coverage build, skipping Helgrind test: ${name}")
-		return()
 	endif()
 
 	if(${location} STREQUAL fs)
@@ -120,6 +87,9 @@
 set(SOURCES_EXAMPLE
 	example.c)
 
+set(SOURCES_TWOLEVEL
+	twolevel.c)
+
 set(LIBS_BASIC
 	vmemcache)
 
@@ -136,6 +106,9 @@
 	${CMAKE_DL_LIBS})
 
 set(LIBS_EXAMPLE
+	vmemcache)
+
+set(LIBS_TWOLEVEL
 	vmemcache)
 
 add_link_executable(vmemcache_test_basic
@@ -158,6 +131,10 @@
 		"${SOURCES_HEAP_USAGE}"
 		"${LIBS_HEAP_USAGE}")
 
+add_link_executable(twolevel
+		"${SOURCES_TWOLEVEL}"
+		"${LIBS_TWOLEVEL}")
+
 if(NOT "${TEST_DIR}" STREQUAL "")
 	test("FS-test-basic" test-basic none fs)
 	test("FS-test-basic-memcheck" test-basic memcheck fs)
@@ -174,6 +151,7 @@
 	test("FS-test-utilization-memcheck" test-utilization memcheck fs)
 	test("FS-test-heap-usage" test-heap-usage none fs)
 	test("FS-test-heap-usage-memcheck" test-heap-usage memcheck fs)
+	test("FS-test-twolevel" test-twolevel none fs)
 endif()
 
 if(NOT "${DEVICE_DAX_PATH}" STREQUAL "")
