=== debian/changelog ===
vmemcache (0.8.1-4) unstable; urgency=medium

  * Give up trying to support 32-bit.  There's no pmem hardware there,
    and won't ever be.  The library is meant for multi-terabyte datasets
    (or shards of even bigger stuff), so 32-bit chroots make little sense,
    either.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 20 Nov 2020 07:04:46 +0100

vmemcache (0.8.1-3) unstable; urgency=medium

  * Disable valgrind tests on mips64* (fails on glibc code).
  * Fix -latomic linkage on m68k.
  * Fix test failure on 32-bit that is also bad-endian.
    You can guess my level of motivation for platforms that are not ever
    going to get pmem hardware...

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 11 Nov 2020 02:37:13 +0100

vmemcache (0.8.1-2) unstable; urgency=medium

  * Fix FTBFS on 32-bit and bad-endian.
  * Fix -latomic linkage (closes: #972967), thanks Adrian Bunk.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 11 Nov 2020 00:04:28 +0100

vmemcache (0.8.1-1) unstable; urgency=medium

  * New upstream point release.
  * dh 12.
  * Add vmemcache_exists to symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 21 Oct 2020 16:10:17 +0200
