=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Maintainer: Adam Borowski <kilobyte@angband.pl>
 Build-Depends:
 	cmake,
-	debhelper (>= 11),
+	debhelper-compat (= 12),
 	pandoc,
 	pkg-config,
-	valgrind [amd64 arm64 armhf i386 mips mipsel mips64 mips64el powerpc ppc64 ppc64el s390x x32]
-Standards-Version: 4.3.0
+	valgrind [amd64 arm64 armhf i386 powerpc ppc64el x32]
+Standards-Version: 4.5.0
 Section: libs
 Homepage: https://github.com/pmem/vmemcache
 Vcs-Browser: https://github.com/kilobyte/vmemcache/tree/debian
@@ -15,7 +15,7 @@
 
 Package: libvmemcache-dev
 Section: libdevel
-Architecture: any
+Architecture: amd64 arm64 ppc64el mips64el s390x alpha ia64 ppc64 riscv64 sparc64
 Multi-Arch: same
 Depends: libvmemcache0 (= ${binary:Version}), ${misc:Depends}
 Description: buffer-based LRU cache
@@ -26,7 +26,7 @@
  This package contains development headers and documentation.
 
 Package: libvmemcache0
-Architecture: any
+Architecture: amd64 arm64 ppc64el mips64el s390x alpha ia64 ppc64 riscv64 sparc64
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: buffer-based LRU cache
